import { SlotInfo, StatusInfo } from "./definitions/adventureland";
import { Attribute, ConditionName, DamageType, GData2, GMonster, MapName, MonsterName, SkillName } from "./definitions/adventureland-data";
import { ActionData, MonsterData } from "./definitions/adventureland-server";
import { Character } from "./Character";
import { Player } from "./Player";
export declare class Entity implements MonsterData, Partial<GMonster> {
    protected G: GData2;
    abs?: false;
    angle: number;
    cid: number;
    going_x: number;
    going_y: number;
    map: MapName;
    move_num: number;
    moving: boolean;
    x: number;
    y: number;
    target: string;
    abilities: {
        [T in SkillName]?: any;
    };
    charge: number;
    cooperative: boolean;
    damage_type: DamageType;
    attack: number;
    frequency: number;
    hp: number;
    mp: number;
    range: number;
    speed: number;
    apiercing: number;
    armor: number;
    avoidance: number;
    blast: number;
    breaks: number;
    crit: number;
    critdamage: number;
    evasion: number;
    lifesteal: number;
    mcourage: number;
    reflection: number;
    resistance: number;
    rpiercing: number;
    aggro: number;
    name: string;
    rage: number;
    respawn: number;
    skin: string;
    "1hp": boolean;
    aa: number;
    achievements: [number, "stat", Attribute, number][];
    announce?: string;
    article?: string;
    balance?: string;
    cute: boolean;
    difficulty?: number;
    escapist: boolean;
    explanation?: string;
    global: boolean;
    goldsteal: number;
    hit?: string;
    humanoid: boolean;
    immune: boolean;
    lucrativeness?: number;
    operator: boolean;
    orientation?: number;
    passive: boolean;
    pet?: {
        aggression: [number, number];
        brightness: number;
        chatter: [number, number];
        courage: [number, number];
        exponential: boolean;
        level: {
            [T in Attribute]?: number;
        };
        obedience: [number, number];
        passion: [number, number];
        xp: number;
    };
    poisonous: boolean;
    prefix: string;
    projectile?: string;
    rbuff: ConditionName;
    roam: boolean;
    size?: number;
    slots?: Partial<SlotInfo>;
    spawns?: [number, MonsterName][];
    special: boolean;
    stationary: boolean;
    supporter: boolean;
    trap: boolean;
    unlist: boolean;
    id: string;
    level: number;
    max_hp: number;
    max_mp: number;
    s: StatusInfo;
    type: MonsterName;
    xp: number;
    constructor(data: MonsterData, map: MapName, G: GData2);
    updateData(data: MonsterData): void;
    calculateDamageRange(defender: Character | Entity | Player): [number, number];
    couldDieToProjectiles(projectiles: Map<string, ActionData>, players: Map<string, Player>, entities: Map<string, Entity>): boolean;
    couldGiveCreditForKill(player: Character): boolean;
    isAttackingPartyMember(player: Character): boolean;
    isAttackingUs(player: Character): boolean;
    isTauntable(by: Character): boolean;
    willBurnToDeath(): boolean;
    willDieToProjectiles(character: Character, projectiles: Map<string, ActionData>, players: Map<string, Player>, entities: Map<string, Entity>): boolean;
}
